From a9a7ed18e688456c38ad7bc9362bfe8e72a0f1c3 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Apr 26 2020 01:02:08 +0000
Subject: [PATCH 368/2232] Remove rust::Vec<T>::operator std::vector<T>


---

diff --git a/gen/write.rs b/gen/write.rs
index 911a3d2..c1aa2f7 100644
--- a/gen/write.rs
+++ b/gen/write.rs
@@ -990,11 +990,6 @@ fn write_rust_vec_extern(out: &mut OutFile, ty: &Type) {
     );
     writeln!(
         out,
-        "void cxxbridge02$rust_vec${}$vector_from(const ::rust::Vec<{}> *ptr, const ::std::vector<{}> &vector) noexcept;",
-        instance, inner, inner
-    );
-    writeln!(
-        out,
         "size_t cxxbridge02$rust_vec${}$len(const ::rust::Vec<{}> *ptr) noexcept;",
         instance, inner,
     );
@@ -1039,22 +1034,6 @@ fn write_rust_vec_impl(out: &mut OutFile, ty: &Type) {
     writeln!(out, "size_t Vec<{}>::size() const noexcept {{", inner);
     writeln!(out, "  return cxxbridge02$rust_vec${}$len(this);", instance);
     writeln!(out, "}}");
-
-    writeln!(out, "template <>");
-    writeln!(
-        out,
-        "Vec<{}>::operator ::std::vector<{}>() const noexcept {{",
-        inner, inner,
-    );
-    writeln!(out, "  ::std::vector<{}> v;", inner);
-    writeln!(out, "  v.reserve(this->size());");
-    writeln!(
-        out,
-        "  cxxbridge02$rust_vec${}$vector_from(this, v);",
-        instance,
-    );
-    writeln!(out, "  return v;");
-    writeln!(out, "}}");
 }
 
 fn write_unique_ptr(out: &mut OutFile, ty: &Type, types: &Types) {
diff --git a/include/cxx.h b/include/cxx.h
index 8f03cbb..c62faad 100644
--- a/include/cxx.h
+++ b/include/cxx.h
@@ -90,7 +90,6 @@ template <typename T>
 class Vec final {
 public:
   size_t size() const noexcept;
-  explicit operator std::vector<T>() const noexcept;
 
 private:
   Vec() noexcept;
diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index 1d40419..f29eeeb 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -583,12 +583,10 @@ fn expand_rust_vec(namespace: &Namespace, ty: &Type, ident: &Ident) -> TokenStre
     let mangled = ty.to_mangled(&namespace.segments) + "$";
     let link_prefix = format!("cxxbridge02$rust_vec${}", mangled);
     let link_drop = format!("{}drop", link_prefix);
-    let link_vector_from = format!("{}vector_from", link_prefix);
     let link_len = format!("{}len", link_prefix);
 
     let local_prefix = format_ident!("{}__vec_", ident);
     let local_drop = format_ident!("{}drop", local_prefix);
-    let local_vector_from = format_ident!("{}vector_from", local_prefix);
     let local_len = format_ident!("{}len", local_prefix);
 
     let span = ty.span();
@@ -598,10 +596,6 @@ fn expand_rust_vec(namespace: &Namespace, ty: &Type, ident: &Ident) -> TokenStre
         unsafe extern "C" fn #local_drop(this: *mut ::cxx::RustVec<#inner>) {
             std::ptr::drop_in_place(this);
         }
-        #[export_name = #link_vector_from]
-        unsafe extern "C" fn #local_vector_from(this: *mut ::cxx::RustVec<#inner>, vector: *mut ::cxx::RealVector<#inner>) {
-            this.as_ref().unwrap().into_vector(vector.as_mut().unwrap());
-        }
         #[doc(hidden)]
         #[export_name = #link_len]
         unsafe extern "C" fn #local_len(this: *const ::cxx::RustVec<#inner>) -> usize {
diff --git a/src/rust_vec.rs b/src/rust_vec.rs
index a28570d..2c8441b 100644
--- a/src/rust_vec.rs
+++ b/src/rust_vec.rs
@@ -1,4 +1,3 @@
-use crate::vector::RealVector;
 use crate::vector::VectorTarget;
 
 #[repr(C)]
@@ -30,10 +29,4 @@ impl<T: VectorTarget<T>> RustVec<T> {
     pub fn len(&self) -> usize {
         self.repr.len()
     }
-
-    pub fn into_vector(&self, vec: &mut RealVector<T>) {
-        for item in &self.repr {
-            vec.push_back(item);
-        }
-    }
 }

